/****************************/
/*   	DIALOG STUFF.C	    */
/* (c)1995-99 Pangea Software  */
/* By Brian Greenstone      */
/****************************/


/****************************/
/*    EXTERNALS             */
/****************************/

#include <QD3DStyle.h>
#include <Controls.h>
#include <TextUtils.h>
#include <Dialogs.h>
#include "myglobals.h"
#include "misc.h"
#include "dialogStuff.h"
#include "mywindows.h"
#include "textureOpt.h"


extern	Boolean	gShowContentStructure,gSaveTextToFile,gReduce32BitTextures;
extern	Boolean	gSaveAsBinary,gConvertToMipmap,gUseFaceNormals;
extern	Boolean	gBlackIsTransparent,gUseCullingGroup;
extern	Boolean	gAutoCenter,gCenterYAtZero,gAverageNormals;
extern	Boolean	gUseBatchSuffix,gCompressTextures, gUseVertexNormals,gKeepVertexColors;
extern	Str255	gBatchSuffix;
extern	long	gMaxTrianglesPerMaterial;
extern	TQ3SubdivisionStyleData	gSubdivData;
extern	float	gScale;

/****************************/
/*    PROTOTYPES            */
/****************************/


/****************************/
/*    CONSTANTS             */
/****************************/


/*********************/
/*    VARIABLES      */
/*********************/




/********************* DO 3DMF OPEN OPTIONS **********************/
//
// OUTPUT:  true = cancelled
//

Boolean Do3DMFOpenOptions(void)
{
DialogPtr 		myDialog;
short			itemType,itemHit;
ControlHandle	itemHandle;
Rect			itemRect;
Boolean			dialogDone,cancelled;

	myDialog = GetNewDialog(128,nil,MOVE_TO_FRONT);
	
				/* SET CONTROL VALUES */
					
	GetDialogItem(myDialog,3,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gShowContentStructure);

	GetDialogItem(myDialog,4,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gSaveTextToFile);
	if (!gShowContentStructure)
		HiliteControl((ControlHandle)itemHandle,255);
	
	
			/* SET OUTLINE FOR USERITEM */
			
	GetDialogItem(myDialog,1,&itemType,(Handle *)&itemHandle,&itemRect);
	SetDialogItem(myDialog, 6, userItem, (Handle)NewUserItemProc(DoBold), &itemRect);
	
	
				/* DO IT */
				
	dialogDone = cancelled = false;
	while(dialogDone == false)
	{
		ModalDialog(nil, &itemHit);
		switch (itemHit)
		{
			case 	1:									// hit ok
					dialogDone = true;
					break;
					
			case	2:									// hit cancel
					cancelled = true;
					dialogDone = true;
					break;
					
			case	3:
					gShowContentStructure = !gShowContentStructure;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gShowContentStructure);
					
					if (!gShowContentStructure)
					{
						GetDialogItem(myDialog,4,&itemType,(Handle *)&itemHandle,&itemRect);
						HiliteControl((ControlHandle)itemHandle,255);
					}
					else
					{
						GetDialogItem(myDialog,4,&itemType,(Handle *)&itemHandle,&itemRect);
						HiliteControl((ControlHandle)itemHandle,0);
					}
					break;
							
			case	4:
					gSaveTextToFile = !gSaveTextToFile;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gSaveTextToFile);
					break;
		}
	}
	DisposeDialog(myDialog);
			
	return(cancelled);
}


/********************* DO 3DMF SAVE OPTIONS **********************/

void DoOptimizationPrefsDialog(void)
{
DialogPtr 		myDialog;
short			itemType,itemHit;
ControlHandle	itemHandle;
Rect			itemRect;
Boolean			dialogDone;
Str255			s;

do_again:
	myDialog = GetNewDialog(129,nil,MOVE_TO_FRONT);
	
				/* SET CONTROL VALUES */
	
	GetDialogItem(myDialog,2,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gSaveAsBinary);

	GetDialogItem(myDialog,3,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,!gSaveAsBinary);

	GetDialogItem(myDialog,6,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gReduce32BitTextures);

	GetDialogItem(myDialog,7,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gBlackIsTransparent);
	
	GetDialogItem(myDialog,8,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gConvertToMipmap);
	
	GetDialogItem(myDialog,9,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gUseFaceNormals);

	GetDialogItem(myDialog,10,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gAverageNormals);
	
	GetDialogItem(myDialog,11,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gUseVertexNormals);

	GetDialogItem(myDialog,12,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gKeepVertexColors);

	GetDialogItem(myDialog,4,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gAutoCenter);

	GetDialogItem(myDialog,5,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gCenterYAtZero);

	GetDialogItem(myDialog,13,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gCompressTextures);

	GetDialogItem(myDialog,17,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gUseCullingGroup);
	
				/* SET STRINGS */
				
	GetDialogItem(myDialog,16,&itemType,(Handle *)&itemHandle,&itemRect);
	NumToString(gMaxTrianglesPerMaterial, s);
	SetDialogItemText((Handle)itemHandle, s);
	
	GetDialogItem(myDialog,18,&itemType,(Handle *)&itemHandle,&itemRect);
	FloatToString(gSubdivData.c1, s);
	SetDialogItemText((Handle)itemHandle, s);
	


			/* SET OUTLINE FOR USERITEM */
			
	GetDialogItem(myDialog,1,&itemType,(Handle *)&itemHandle,&itemRect);			// OK
	SetDialogItem(myDialog, 21, userItem, (Handle)NewUserItemProc(DoBold), &itemRect);
	
	
				/* DO IT */
				
	dialogDone = false;
	while(dialogDone == false)
	{
		ModalDialog(nil, &itemHit);
		switch (itemHit)
		{
			case 	1:									// hit ok
					dialogDone = true;
					break;
							
			case	2:
			case	3:
					gSaveAsBinary = !gSaveAsBinary;
					GetDialogItem(myDialog,2,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gSaveAsBinary);
					GetDialogItem(myDialog,3,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,!gSaveAsBinary);
					break;
		
			case	4:
					gAutoCenter = !gAutoCenter;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gAutoCenter);
					break;
					
			case	5:
					gCenterYAtZero = !gCenterYAtZero;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gCenterYAtZero);
					break;
					
			case	6:
					gReduce32BitTextures = !gReduce32BitTextures;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gReduce32BitTextures);
					break;

			case	7:
					gBlackIsTransparent = !gBlackIsTransparent;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gBlackIsTransparent);
					break;

			case	8:
					gConvertToMipmap = !gConvertToMipmap;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gConvertToMipmap);
					break;

			case	9:
					gUseFaceNormals = !gUseFaceNormals;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gUseFaceNormals);
					break;

			case	10:
					gAverageNormals = !gAverageNormals;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gAverageNormals);
					break;

			case	11:
					gUseVertexNormals = !gUseVertexNormals;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gUseVertexNormals);
					break;					

			case	12:
					gKeepVertexColors = !gKeepVertexColors;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gKeepVertexColors);
					break;					

			case	13:
					gCompressTextures = !gCompressTextures;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gCompressTextures);
					break;	
					
			case	14:
					DisposeDialog(myDialog);
					GetMyCompressionInfo();
					goto do_again;
					break;				
					
			case	16:
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					GetDialogItemText((Handle)itemHandle, s);
					StringToNum(s,&gMaxTrianglesPerMaterial);
					break;
					
			case	17:
					gUseCullingGroup = !gUseCullingGroup;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gUseCullingGroup);
					break;
					
			case	18:
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					GetDialogItemText((Handle)itemHandle, s);
					gSubdivData.c1 = gSubdivData.c2 = StringToFloat(s);
					break;
					
		}
	}
	DisposeDialog(myDialog);
}


/********************* DO BATCH PREFS DIALOG **********************/

void DoBatchPrefsDialog(void)
{
DialogPtr 		myDialog;
short			itemType,itemHit;
ControlHandle	itemHandle;
Rect			itemRect;
Boolean			dialogDone,cancelled;

	myDialog = GetNewDialog(130,nil,MOVE_TO_FRONT);
	
				/* SET CONTROL VALUES */
					
	GetDialogItem(myDialog,2,&itemType,(Handle *)&itemHandle,&itemRect);
	SetControlValue((ControlHandle)itemHandle,gUseBatchSuffix);

	GetDialogItem(myDialog,3,&itemType,(Handle *)&itemHandle,&itemRect);
	SetDialogItemText((Handle)itemHandle, gBatchSuffix);
		
				/* DO IT */
				
	dialogDone = cancelled = false;
	while(dialogDone == false)
	{
		ModalDialog(nil, &itemHit);
		switch (itemHit)
		{
			case 	1:									// hit ok
					dialogDone = true;
					break;
					
			case	2:
					gUseBatchSuffix = !gUseBatchSuffix;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					SetControlValue((ControlHandle)itemHandle,gUseBatchSuffix);					
					break;
							
			case	3:
					gSaveTextToFile = !gSaveTextToFile;
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					GetDialogItemText((Handle)itemHandle, gBatchSuffix);
					break;
		}
	}
	DisposeDialog(myDialog);
}




/********************* DO SCALE DIALOG **********************/
//
// OUTPUT:  true = cancelled
//

Boolean DoScaleDialog(void)
{
DialogPtr 		myDialog;
short			itemType,itemHit;
ControlHandle	itemHandle;
Rect			itemRect;
Boolean			dialogDone,cancelled;
Str32			s;

	myDialog = GetNewDialog(131,nil,MOVE_TO_FRONT);
	
				/* SET CONTROL VALUES */
					
	FloatToString(gScale,s);
	GetDialogItem(myDialog,5,&itemType,(Handle *)&itemHandle,&itemRect);
	SetDialogItemText((Handle)itemHandle, s);
	
	
			/* SET OUTLINE FOR USERITEM */
			
	GetDialogItem(myDialog,1,&itemType,(Handle *)&itemHandle,&itemRect);
	SetDialogItem(myDialog, 6, userItem, (Handle)NewUserItemProc(DoBold), &itemRect);
	
	
				/* DO IT */
				
	dialogDone = cancelled = false;
	while(dialogDone == false)
	{
		ModalDialog(nil, &itemHit);
		switch (itemHit)
		{
			case 	1:									// hit ok
					dialogDone = true;
					break;
					
			case	2:									// hit cancel
					cancelled = true;
					dialogDone = true;
					break;
					
			case	5:
					GetDialogItem(myDialog,itemHit,&itemType,(Handle *)&itemHandle,&itemRect);
					GetDialogItemText((Handle)itemHandle, s);
					gScale = StringToFloat(s);
					break;
		}
	}
	DisposeDialog(myDialog);
			
	return(cancelled);
}


















