//
// bg3d.h
//

#ifndef __BG3D
#define __BG3D

#include <gl.h>

#define	MAX_MULTITEXTURE_LAYERS		4			// max # of multi texture layers supported

typedef struct
{
	char			headerString[16];			// header string
	NumVersion		version;					// version of file
}BG3DHeaderType;


	/* BG3D MATERIAL FLAGS */
		
enum
{
	BG3D_MATERIALFLAG_TEXTURED		= 	1,
	BG3D_MATERIALFLAG_TRANSPARENT	=	(1<<1)
	
};


		/* TAG TYPES */
		
enum
{
	BG3D_TAGTYPE_MATERIALFLAGS,
	BG3D_TAGTYPE_MATERIALDIFFUSECOLOR,
	BG3D_TAGTYPE_TEXTUREMAP,
	BG3D_TAGTYPE_GROUPSTART,
	BG3D_TAGTYPE_GROUPEND,	
	BG3D_TAGTYPE_GEOMETRY,
	BG3D_TAGTYPE_VERTEXARRAY,
	BG3D_TAGTYPE_NORMALARRAY,
	BG3D_TAGTYPE_UVARRAY,
	BG3D_TAGTYPE_COLORARRAY,
	BG3D_TAGTYPE_TRIANGLEARRAY,
	BG3D_TAGTYPE_ENDFILE

};


typedef struct
{
	u_long	width,height;					// dimensions of texture
	GLint	pixelFormat;					// OGL format (GL_RGBA, etc.)
	u_long	bufferSize;						// size of texture data to follow
	u_long	reserved[4];					// for future use
}BG3DTextureHeader;


	/* GEOMETRY TYPES */
	
enum
{
	BG3D_GEOMETRYTYPE_VERTEXELEMENTS

};

typedef struct
{
	u_long	type;								// geometry type
	int		numMaterials;						// # material layers
	u_long	materialNum[MAX_MULTITEXTURE_LAYERS];	// index into material list
	u_long	flags;								// flags
	u_long	numPoints;							// (if applicable)
	u_long	numTriangles;						// (if applicable)
	u_long	reserved[4];						// for future use
}BG3DGeometryHeader;


//-----------------------------------

void ExportBG3D(void);



#endif

