/*
** Copyright  1996 - 1998, Conix Graphics.
** All Rights Reserved.
** 
** This source code is the property of Conix Graphics.  The contents of
** this file may not be copied or duplicated in any form, in whole or in
** part, without the prior written permission of Conix Graphics.
** 
*/

#ifndef _GLDVERTEX_H
#define _GLDVERTEX_H

#include "gl.h"
#include "glt.h"

#ifdef __cplusplus
extern "C" {
#endif


/*
** Vertex data type
*/
typedef struct {
	/* Vertex coordinates */	
	GLTCoord4     object;
	GLTCoord4     eye;
	GLTCoord4     clip;
	GLTCoord4     window;
	
	/* Vertex color */
	GLTColor4     color;
	
	/* Texture coordinates */
	GLTTexCoord4  texture;
	
	/* Normal vector */
	GLTCoord3     normal;
	
	/* Reserved data */
	const void   *reserved1;
	const void   *reserved2;

	/* Flags */
	GLboolean     edge;
	GLboolean     clipped;

	/* Reserved data */
	GLboolean     reserved3;
	GLboolean     reserved4;
} GLDVertex;


#ifdef __cplusplus
}
#endif

#endif /* _GLDVERTEX_H */
