/*
** Copyright  1994 - 1998, Conix Graphics.
** All Rights Reserved.
** 
** This source code is the property of Conix Graphics.  The contents of
** this file may not be copied or duplicated in any form, in whole or in
** part, without the prior written permission of Conix Graphics.
** 
*/

#ifndef _GLT_H
#define _GLT_H

#include "gl.h"

#ifdef __cplusplus
extern "C" {
#endif


typedef GLfloat GLTcolor;
typedef GLint   GLTfixedColor;
typedef GLfloat GLTcoord;
typedef GLint   GLTfixedCoord;
typedef GLfloat GLTtexCoord;
typedef GLubyte GLTtexComp;

/* Data types */
typedef struct {
	GLTcoord x;
	GLTcoord y;
	GLTcoord z;
	GLTcoord w;
} GLTCoord4;

typedef struct {
	GLTcoord x;
	GLTcoord y;
	GLTcoord z;
} GLTCoord3;

typedef struct {
	GLTcoord x;
	GLTcoord y;
} GLTCoord2;

typedef struct {
	GLTtexCoord s;
	GLTtexCoord t;
	GLTtexCoord r;
	GLTtexCoord q;
} GLTTexCoord4;

typedef struct {
	GLTcolor r;
	GLTcolor g;
	GLTcolor b;
	GLTcolor a;
} GLTColor4;

typedef struct {
	GLTcolor r;
	GLTcolor g;
	GLTcolor b;
} GLTColor3;

typedef struct {
	GLTfixedColor r;
	GLTfixedColor g;
	GLTfixedColor b;
	GLTfixedColor a;
} GLTFixedColor4;

typedef struct {
	GLTfixedColor r;
	GLTfixedColor g;
	GLTfixedColor b;
} GLTFixedColor3;

typedef struct {
	GLint   x;
	GLint   y;
	GLsizei w;
	GLsizei h;
} GLTRectangle;

typedef struct {
	GLsizei w;
	GLsizei h;
} GLTDimensions;

typedef struct {
	GLTcoord p1;
	GLTcoord p2;
	GLTcoord p3;
	GLTcoord p4;
} GLTPlane;


#ifdef __cplusplus
}
#endif

#endif /* _GLT_H */
