//
// optimize.h
// 


#define	TARGET_SIZE				8.0

#define	MAX_VERTS_IN_FACE		256

typedef	struct
{
	TQ3Point3D	vertexCoords[3];
	TQ3Vector3D	vertexNormals[3];
	TQ3Vector3D	faceNormal;
	TQ3Param2D	vertexUVs[3];
}TriangleDefType;


typedef struct
{
	TQ3ColorRGB	color[3];						// 3 vertices, so 3 colors
}TriangleVertexColorsType;



typedef struct
{
	Boolean					merged;				// true == this material has already been merged with another with duplicate texture
	long					numTrianglesInList;
	
	Boolean					isTextured;			// true == is a textured material, otherwise colored
	TQ3SurfaceShaderObject	textureRef;			// ptr to texture shader ref (for textured materials)
	TQ3ColorRGB				color;				// color value (for colored materials only)
	TriangleDefType			*triangleList;
	
	Boolean					hasVertexColors;	// true = has vertex colors
	TriangleVertexColorsType	*vertexColors;
	
	Boolean					isTransparent;		// true == is a transparent material
	TQ3ColorRGB				transColor;			// transparency color value
}MaterialType;

//====================================================


extern	void OptimizeGeometry(void);
extern	void PreTransformTri(TQ3GeometryObject theTriangle, TQ3TriangleData *inData);
extern	void AddTriToTriangleLists(TQ3Object theTri, TQ3TriangleData *inData);
extern	void ConvertTriangleListsToTriMeshes(void);
extern	void OptimizationInit(void);
void AddTriangleToTriangleList(TQ3Point3D *coords, TQ3Vector3D *vertexNormals, TQ3Vector3D *faceNormal,
								TQ3Param2D *vertexUVs, MaterialType *materialType, TQ3ColorRGB *vertexColors);
extern	void BuildDisplayModel(void);






