/****************************/
/*        WINDOWS           */
/* (c)1995 Pangea Software  */
/* By Brian Greenstone      */
/****************************/


/***************/
/* EXTERNALS   */
/***************/

#include 	<Rave.h>
#include 	<Files.h>
#include 	<Resources.h>
#include 	<Dialogs.h>
#include	"myglobals.h"
#include	"mywindows.h"
#include	"misc.h"
#include "qd3d_support.h"
#include	"gl.h"
#include	"atirave.h"


extern	Boolean		gShowContentStructure,gSaveTextToFile;
extern	FSSpec		gStreamFSSpec;
extern	short		gStreamRefNum;
extern	QD3DSetupOutputType		gModelViewInfo;

/****************************/
/*    PROTOTYPES            */
/****************************/

static void MyRaveInvalidateCallback(TQ3RendererObject rendererRef);


/****************************/
/*    CONSTANTS             */
/****************************/

#define	MIN_WINDOW_HEIGHT	50
#define	MIN_WINDOW_WIDTH	50

#define	MAX_CONTEXTS		4

/**********************/
/*     VARIABLES      */
/**********************/

Boolean		gUseGLBlending = false;

Rect		gSizeRect;
short		gHtab = 10;


WindowPtr	gBreakdownWindow = nil,gWaitWindow;

unsigned long	gNumContexts = 0;
TQADrawContext 	*gContexts[MAX_CONTEXTS];						// pointer to array of (TQADrawContext *)
unsigned long	gNumEngines = 0;
TQAEngine	 	*gEngines[MAX_CONTEXTS];						// pointer to array of (TQAEngine *)


/**********************/
/*  INIT WINDOW STUFF */
/**********************/

void InitWindowStuff(void)
{
			/*  SET SIZE RECT */

	gSizeRect.top	=	MIN_WINDOW_HEIGHT;
	gSizeRect.left	=	MIN_WINDOW_WIDTH;
	
	gSizeRect.right	=	qd.screenBits.bounds.right -
						qd.screenBits.bounds.left;
	
	gSizeRect.bottom =	qd.screenBits.bounds.bottom -
						qd.screenBits.bounds.top;

}




/*********************** DUMP GWORLD **********************/
//
//    
//   

void DumpGWorld(GWorldPtr thisWorld, WindowPtr thisWindow)
{
Rect		tempRect;
GrafPtr		oldPort;
PixMapHandle pm;

	DoLockPixels(thisWorld);

	GetPort(&oldPort);
	pm = GetGWorldPixMap(thisWorld);	
	if ((pm == nil) | (*pm == nil) )
		DoAlert("\pPixMap Handle or Ptr = Null?!");

	LockPixels(pm);

	SetPort(thisWindow);
			
	tempRect = thisWindow->portRect;
			
	ForeColor(blackColor);
	BackColor(whiteColor);
		
	CopyBits((BitMap *)*pm,&(qd.thePort->portBits),
			&(thisWorld->portRect),&tempRect,srcCopy,0);

	SetPort(oldPort);
}

/*********************** DUMP GWORLD 2 **********************/
//
//    copies to a destination RECT
//

void DumpGWorld2(GWorldPtr thisWorld, WindowPtr thisWindow,Rect *destRect)
{
PixMapHandle pm;

	DoLockPixels(thisWorld);

	pm = GetGWorldPixMap(thisWorld);	
	if ((pm == nil) | (*pm == nil) )
		DoAlert("\pPixMap Handle or Ptr = Null?!");

	ForeColor(blackColor);
	BackColor(whiteColor);
		
	CopyBits((BitMap *)*pm,&(thisWindow->portBits),
			destRect,destRect,srcCopy,0);

	DoUnlockPixels(thisWorld);
}

/*********************** DUMP GWORLD 3 **********************/
//
//    copies RECT to RECT
//

void DumpGWorld3(GWorldPtr thisWorld, WindowPtr thisWindow,Rect *srcRect,Rect *destRect)
{
PixMapHandle pm;

	DoLockPixels(thisWorld);

	pm = GetGWorldPixMap(thisWorld);	
	if ((pm == nil) | (*pm == nil) )
		DoAlert("\pPixMap Handle or Ptr = Null?!");

	ForeColor(blackColor);
	BackColor(whiteColor);
		
	CopyBits((BitMap *)*pm,&(thisWindow->portBits),
			srcRect,destRect,srcCopy,0);

//	DoUnlockPixels(thisWorld);
}


/*********************** DUMP GWORLD TO GWORLD **********************/
//
//    copies RECT to RECT
//

void DumpGWorldToGWorld(GWorldPtr thisWorld, GWorldPtr destWorld,Rect *srcRect,Rect *destRect)
{
PixMapHandle pm,pm2;
GDHandle	oldGD;
GWorldPtr	oldGW;

	GetGWorld (&oldGW,&oldGD);
	SetGWorld(destWorld,nil);	
	ForeColor(blackColor);
	BackColor(whiteColor);

	SetGWorld(thisWorld,nil);	
	ForeColor(blackColor);
	BackColor(whiteColor);

	DoLockPixels(destWorld);
	DoLockPixels(thisWorld);

	pm = GetGWorldPixMap(thisWorld);	
	if ((pm == nil) | (*pm == nil) )
		DoAlert("\pPixMap Handle or Ptr = Null?!");

	pm2 = GetGWorldPixMap(destWorld);	
	if ((pm2 == nil) | (*pm2 == nil) )
		DoAlert("\pPixMap Handle or Ptr = Null?!");

		
	CopyBits((BitMap *)*pm,(BitMap *)*pm2,
			srcRect,destRect,srcCopy,0);

	SetGWorld(oldGW,oldGD);								// restore gworld

}



/******************* DO LOCK PIXELS **************/

void DoLockPixels(GWorldPtr world)
{
PixMapHandle pm;
	
	pm = GetGWorldPixMap(world);
	if (LockPixels(pm) == false)
		DoFatalAlert("\pPixMap Went Bye,Bye?!");
}


/***************** DO UNLOCK PIXELS **************/

void DoUnlockPixels(GWorldPtr world)
{
	PixMapHandle pm;
	
		pm = GetGWorldPixMap(world);
		UnlockPixels(pm);
}


/*==============================================================================
* Dobold ()
* this is the user item procedure to make the thick outline around the default
* button (assumed to be item 1)
*=============================================================================*/

pascal void DoBold (WindowPtr dlogPtr, short item)
{
short		itype;
Handle		ihandle;
Rect		irect;

	item;	/* unused */

	GetDialogItem (dlogPtr, 1, &itype, (Handle *)&ihandle, &irect);	/* get the buttons rect */
	PenSize (3, 3);											/* make thick lines	*/
	InsetRect (&irect, -4, -4);							/* grow rect a little   */
	FrameRoundRect (&irect, 16, 16);						/* frame the button now */
	PenNormal ();
}

/*==============================================================================
* DoOutline ()
* this is the user item procedure to make the thin outline around the given useritem
*=============================================================================*/

pascal void DoOutline (WindowPtr dlogPtr, short item)
{
short		itype;
Handle		ihandle;
Rect		irect;

	GetDialogItem (dlogPtr, item, &itype, (Handle *)&ihandle, &irect);	// get the user item's rect 
	FrameRect (&irect);						// frame the button now 
	PenNormal();
}


/*************** HOME *****************/

void Home(void)
{
GrafPtr	port;
Rect	r;

	if (gShowContentStructure)
	{
		gHtab = 12;
		MoveTo(gHtab,10);
		GetPort(&port);
		r = port->portRect;
		EraseRect(&r);
	}
}

/************* DO CR *****************/

void DoCR(void)
{
Point	pt;
GrafPtr	port;
Rect	r;
static	char	cr = CHAR_RETURN;
static	char	sp = ' ';
static long		count = 1;
OSErr	iErr;
short	i;

	if (gShowContentStructure)
	{
		GetPen(&pt);
		MoveTo(gHtab,pt.v+12);
		
		GetPort(&port);
		r = port->portRect;
		GetPen(&pt);
		if (pt.v >= (r.bottom-20))
		{
			ScrollRect(&r, 0, -12, nil);
			Move(0,-12);
		}
	}	
			/* HANDLE TEXT FILE OUTPUT */
			

	if (gShowContentStructure && gSaveTextToFile)
	{
		iErr = FSWrite(gStreamRefNum, &count, &cr);		// write <CR> to file
		if (iErr)
			DoFatalAlert("\pError writing to output TEXT file.");
			
		for (i = 0; i < (gHtab/5); i++)
		{
			iErr = FSWrite(gStreamRefNum, &count, &sp);		// write ' ' to file for htab indenting
			if (iErr)
				DoFatalAlert("\pError writing to output TEXT file.");
		}
	}
}

/***************** WRITE STRING **********************/

void WriteString(Str255 s)
{
long	count;
OSErr	iErr;

			/* DRAW TO WINDOW */
		
	if (gShowContentStructure)
	{		
		DrawString(s);
	}
			/* HANDLE TEXT FILE OUTPUT */
			

	if (gShowContentStructure && gSaveTextToFile)
	{
		count = s[0];									// set length of string
	
		iErr = FSWrite(gStreamRefNum, &count, &s[1]);		// write string to file
		if (iErr)
			DoFatalAlert("\pError writing to output TEXT file.");
	}

}


/***************** WRITE CHAR **********************/

void WriteChar(char c)
{
long	count;
OSErr	iErr;

			/* DRAW TO WINDOW */
		
	if (gShowContentStructure)
	{		
		DrawChar(c);
	}
			/* HANDLE TEXT FILE OUTPUT */
			

	if (gShowContentStructure && gSaveTextToFile)
	{
		count = 1;									// set length of char
	
		iErr = FSWrite(gStreamRefNum, &count, &c);		// write char to file
		if (iErr)
			DoFatalAlert("\pError writing to output TEXT file.");
	}

}



/****************** INIT BREAKDOWN WINDOW **************************/

void InitBreakdownWindow(void)
{
	if (gBreakdownWindow == nil)
	{
		gBreakdownWindow = GetNewCWindow(129, nil,MOVE_TO_FRONT);
		if (gBreakdownWindow == nil)
			DoFatalAlert("\pWhere did the gBreakdownWindow window go?");
	}
	SetPort((GrafPtr)gBreakdownWindow);
}


/********************* SHOW WAITING WINDOW ************************/

void ShowWaitingWindow(void)
{
PicHandle 	p;
Rect		r;


	gWaitWindow = GetNewCWindow(130, nil,MOVE_TO_FRONT);
	SetPort((GrafPtr)gWaitWindow);

	p = GetPicture(130);
	r = (**p).picFrame;
	DrawPicture(p, &r);
	ReleaseResource((Handle)p);	
}


void KillWaitingWindow(void)
{
	DisposeWindow(gWaitWindow);
}


#pragma mark =========== RAVE CONTEXT STUFF ====================



/********************** GET MY RAVE INFO ***********************/
//
// Gets pointers to the RAVE Draw Contexts uses by our view and renderer.
//

void GetMyRAVEInfo(void)
{
TQ3ViewObject		theView;
TQ3RendererObject	theRenderer;
TQ3Status			status, viewStatus;
TQAEngine	 		*engines[MAX_CONTEXTS];
int					i,j;

			/* GET RENDERER FROM VIEW */

	theView = gModelViewInfo.viewObject;
	status = Q3View_GetRenderer(theView,&theRenderer);
	if (status == kQ3Failure)
		DoFatalAlert("\pGetMyRAVEInfo: Q3View_GetRenderer failed!");
		
	
			/*************************/
			/* GET THE RAVE CONTEXTS */
			/*************************/
			//
			// 1. 	Call _StartRendering to make sure RAVE contexts have been created.
			// 2.	Call _GetRAVEDrawContexts to retrieve the RAVE contexts & setup a callback.
			// 3.	Call _Cancel & _EndRendering to finish it.
			//			

	viewStatus = Q3View_StartRendering(theView);								// enter render loop
	
	status = Q3InteractiveRenderer_GetRAVEDrawContexts(theRenderer,				// pass in renderer
													 gContexts,					// fill this array with pointers to Draw Contexts
													 engines,					// fill this array with pointers to Draw Engines
													 &gNumContexts,				// recieves # draw contexts gotten
													 MyRaveInvalidateCallback);	// callback function to use when Contexts change
	if (status == kQ3Failure)
		DoFatalAlert("\pGetMyRAVEInfo: Q3InteractiveRenderer_GetRAVEDrawContexts failed!");
	
	if (viewStatus == kQ3Success)												// if we're in a render loop, we need to cancel it
	{
		status = Q3View_Cancel(theView);										// exit render loop
		if (status == kQ3Failure)
			DoFatalAlert("\pGetMyRAVEInfo: Q3View_Cancel failed!");
		Q3View_EndRendering(theView);											// *must* call EndRendering after a Cancel
	}

			/* VERIFY IF WE GOT ANYTHING */
			//
			// NOTE: if the user window shades a window, then we might
			//		get zero here.  An app should handle this gracefully,
			//		but we are not really doing so here.  Here we just bail out
			//		but we never attempt to get the draw contexts again.
			//
			
			
	if (gNumContexts == 0)
	{
//		DoAlert("\pNo RAVE Contexts exist");
		return;
	}
		
		
		/* REMOVE DUPLICATES FROM ENGINES LIST */
		//
		// _GetRAVEDrawContexts returns a list of Draw Contexts and a parallel list of Drawing Engines for each Draw Context.
		// The Engines list may contain multiple copies of the same engine since different Draw Contexts can use the
		// same drawing engine (ie. multiple 3D windows on the same monitor).  Here, we scan thru the list and remove
		// the duplicates since we only want one copy of each engine for this test app.
		//

	gNumEngines = 0;
	
	for (i = 0; i < gNumContexts; i++)
	{
		for (j = 0; j < gNumEngines; j++)				// see if this engine is already in the global list
		{		
			if (engines[i] == gEngines[j])
				goto skip_me;
		}
		gEngines[gNumEngines++] = engines[i];			// this engine is unique, so put into global list		
skip_me:;		
	}	
				
				/* CLEAN UP */
				
	Q3Object_Dispose(theRenderer);						
	
	DoMyRAVECalls();
}


/******************* DO MY RAVE CALLS ************************/
//
// Uses the RAVE Draw Contexts to set up some fun stuff.
//

void DoMyRAVECalls(void)
{
int			i;

	for (i = 0; i < gNumContexts; i++)						// set the RAVE info on *all* of the contexts
	{
		QASetInt(gContexts[i], kQATag_TextureFilter, kQATextureFilter_Best);
		QASetInt(gContexts[i], (TQATagInt)kATITexCompress, kQATexture_NoCompression);
	
				/* LET'S CHANGE THE BLENDING MODE */
	
		if (gUseGLBlending)
		{
			QASetInt(gContexts[i], kQATag_Blend, kQABlend_OpenGL);
			QASetInt(gContexts[i], kQATagGL_BlendSrc, GL_SRC_ALPHA);
			QASetInt(gContexts[i], kQATagGL_BlendDst, GL_ONE_MINUS_SRC_ALPHA);
		}
		else
			QASetInt(gContexts[i], kQATag_Blend, kQABlend_PreMultiply);
	}
}


/****************** MY RAVE INVALIDATE CALLBACK ***********************/
//
//	INPUT:	rendererRef = reference to the renderer calling the callback.
//						You must not dispose of this reference in the callback!
//

static void MyRaveInvalidateCallback(TQ3RendererObject rendererRef)
{
	rendererRef;										// unused

	gNumContexts = 0;									// we aint got no contexts no more
		
			/* GET NEW RAVE CONTEXTS & RESET THE RAVE TAGS */

	GetMyRAVEInfo();								// get the contexts & engines
	DoMyRAVECalls();								// make my RAVE calls again to keep things setup the way I like
}




















